osg::Transform Class Reference

`#include <Transform>`

Inheritance diagram for osg::Transform:

## Public Types

enum | ReferenceFrame { RELATIVE_RF , ABSOLUTE_RF , ABSOLUTE_RF_INHERIT_VIEWPOINT }
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Transform ()
| Transform (const Transform &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Transform)
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual MatrixTransform * | asMatrixTransform ()
virtual const MatrixTransform * | asMatrixTransform () const
virtual PositionAttitudeTransform * | asPositionAttitudeTransform ()
virtual const PositionAttitudeTransform * | asPositionAttitudeTransform () const
virtual AutoTransform * | asAutoTransform ()
virtual const AutoTransform * | asAutoTransform () const
void | setReferenceFrame (ReferenceFrame rf)
ReferenceFrame | getReferenceFrame () const
virtual bool | computeLocalToWorldMatrix (Matrix &matrix, NodeVisitor *) const
virtual bool | computeWorldToLocalMatrix (Matrix &matrix, NodeVisitor *) const
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual void | traverse (NodeVisitor &nv)
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Transform ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

ReferenceFrame | _referenceFrame
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

A Transform is a group node for which all children are transformed by a 4x4 matrix. It is often used for positioning objects within a scene, producing trackball functionality or for animation.

Transform itself does not provide set/get functions, only the interface for defining what the 4x4 transformation is. Subclasses, such as MatrixTransform and PositionAttitudeTransform support the use of an osg::Matrix or a Vec3 and Quat respectively.

Note: If the transformation matrix scales the subgraph then the normals of the underlying geometry will need to be renormalized to be unit vectors once more. This can be done transparently through OpenGL's use of either GL_NORMALIZE and GL_RESCALE_NORMAL modes. For further background reading see the glNormalize documentation in the OpenGL Reference Guide (the blue book). To enable it in the OSG, you simply need to attach a local osg::StateSet to the osg::Transform, and set the appropriate mode to ON via stateset->setMode(GL_NORMALIZE, osg::StateAttribute::ON);

## Member Enumeration Documentation

## ReferenceFrame

enum osg::Transform::ReferenceFrame

Enumerator
RELATIVE_RF |
ABSOLUTE_RF |
ABSOLUTE_RF_INHERIT_VIEWPOINT |

## Constructor & Destructor Documentation

## Transform() [1/2]

osg::Transform::Transform | ( |  | ) |

Referenced by asTransform(), asTransform(), osg::CameraView::CameraView(), META_Node(), osg::PositionAttitudeTransform::PositionAttitudeTransform(), and Transform().

## Transform() [2/2]

osg::Transform::Transform | ( | const Transform & | ,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References osg::CopyOp::SHALLOW_COPY, and Transform().

## ~Transform()

virtual osg::Transform::~Transform | ( |  | ) |

protected virtual

## Member Function Documentation

## asAutoTransform() [1/2]

virtual AutoTransform * osg::Transform::asAutoTransform | ( |  | ) |

inline virtual

Reimplemented in osg::AutoTransform.

## asAutoTransform() [2/2]

virtual const AutoTransform * osg::Transform::asAutoTransform | ( |  | ) | const

inline virtual

Reimplemented in osg::AutoTransform.

## asMatrixTransform() [1/2]

virtual MatrixTransform * osg::Transform::asMatrixTransform | ( |  | ) |

inline virtual

Reimplemented in osg::MatrixTransform.

## asMatrixTransform() [2/2]

virtual const MatrixTransform * osg::Transform::asMatrixTransform | ( |  | ) | const

inline virtual

Reimplemented in osg::MatrixTransform.

## asPositionAttitudeTransform() [1/2]

virtual PositionAttitudeTransform * osg::Transform::asPositionAttitudeTransform | ( |  | ) |

inline virtual

Reimplemented in osg::PositionAttitudeTransform.

## asPositionAttitudeTransform() [2/2]

virtual const PositionAttitudeTransform * osg::Transform::asPositionAttitudeTransform | ( |  | ) | const

inline virtual

Reimplemented in osg::PositionAttitudeTransform.

## asTransform() [1/2]

virtual Transform * osg::Transform::asTransform | ( |  | ) |

inline virtual

Convert 'this' into a Transform pointer if Node is a Transform, otherwise return 0. Equivalent to dynamic_cast<Transform*>(this).

Reimplemented from osg::Node.

References Transform().

## asTransform() [2/2]

virtual const Transform * osg::Transform::asTransform | ( |  | ) | const

inline virtual

convert 'const this' into a const Transform pointer if Node is a Transform, otherwise return 0. Equivalent to dynamic_cast<const Transform*>(this).

Reimplemented from osg::Node.

References Transform().

## computeBound()

virtual BoundingSphere osg::Transform::computeBound | ( |  | ) | const

virtual

Overrides Group's computeBound. There is no need to override in subclasses from osg::Transform since this computeBound() uses the underlying matrix (calling computeMatrix if required).

Reimplemented from osg::Group.

## computeLocalToWorldMatrix()

virtual bool osg::Transform::computeLocalToWorldMatrix | ( | Matrix & | matrix,
|  | NodeVisitor * | ) const

inline virtual

Reimplemented in osg::AutoTransform, osg::Camera, osg::CameraView, osg::MatrixTransform, osg::PositionAttitudeTransform, osgManipulator::AntiSquish, osgPresentation::HUDTransform, osgPresentation::Timeout, and osgSim::DOFTransform.

References _referenceFrame, osg::Matrixd::makeIdentity(), and RELATIVE_RF.

## computeWorldToLocalMatrix()

virtual bool osg::Transform::computeWorldToLocalMatrix | ( | Matrix & | matrix,
|  | NodeVisitor * | ) const

inline virtual

Reimplemented in osg::AutoTransform, osg::Camera, osg::CameraView, osg::MatrixTransform, osg::PositionAttitudeTransform, osgManipulator::AntiSquish, osgPresentation::HUDTransform, osgPresentation::Timeout, and osgSim::DOFTransform.

References _referenceFrame, osg::Matrixd::makeIdentity(), and RELATIVE_RF.

## getReferenceFrame()

ReferenceFrame osg::Transform::getReferenceFrame | ( |  | ) | const

inline

References _referenceFrame.

## META_Node()

osg::Transform::META_Node | ( | osg | ,
|  | Transform | )

References Transform().

## setReferenceFrame()

void osg::Transform::setReferenceFrame | ( | ReferenceFrame | rf | ) |

Set the transform's ReferenceFrame, either to be relative to its parent reference frame, or relative to an absolute coordinate frame. RELATIVE_RF is the default. Note: Setting the ReferenceFrame to be ABSOLUTE_RF will also set the CullingActive flag on the transform, and hence all of its parents, to false, thereby disabling culling of it and all its parents. This is necessary to prevent inappropriate culling, but may impact cull times if the absolute transform is deep in the scene graph. It is therefore recommended to only use absolute Transforms at the top of the scene, for such things as heads up displays. ABSOLUTE_RF_INHERIT_VIEWPOINT is the same as ABSOLUTE_RF except it adds the ability to use the parents view points position in world coordinates as its local viewpoint in the new coordinates frame. This is useful for Render to texture Cameras that wish to use the main views LOD range computation (which uses the viewpoint rather than the eye point) rather than use the local eye point defined by the this Transforms' absolute view matrix.

## Member Data Documentation

## _referenceFrame

ReferenceFrame osg::Transform::_referenceFrame

protected

Referenced by computeLocalToWorldMatrix(), computeWorldToLocalMatrix(), and getReferenceFrame().

The documentation for this class was generated from the following file:

- Transform